package com.example.calculator2;

import android.os.Bundle;
import android.app.Activity;
import android.text.Editable;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;
import android.view.View.*;

@SuppressWarnings("unused")
public class MainActivity extends Activity {
	
	EditText disp; 
	int op1; 
	int op2; 
	String operator;
	
	@Override protected void onCreate(Bundle savedInstanceState) { 
		super.onCreate(savedInstanceState); 
		setContentView(R.layout.activity_main); 
		
		Button cancel, equal;
		Button[] textButtons = new Button[10];
		Button[] operatorButtons = new Button[4];

		// create array of numeric buttons
		textButtons[0] = (Button) findViewById(R.id.zero);
		textButtons[1] = (Button) findViewById(R.id.one); 
		textButtons[2] = (Button) findViewById(R.id.two); 
		textButtons[3] = (Button) findViewById(R.id.three); 
		textButtons[4] = (Button) findViewById(R.id.four); 
		textButtons[5] = (Button) findViewById(R.id.five); 
		textButtons[6] = (Button) findViewById(R.id.six); 
		textButtons[7] = (Button) findViewById(R.id.seven); 
		textButtons[8] = (Button) findViewById(R.id.eight); 
		textButtons[9] = (Button) findViewById(R.id.nine); 

		// create array of operator buttons
		operatorButtons[0] = (Button) findViewById(R.id.add); 
		operatorButtons[1] = (Button) findViewById(R.id.sub); 
		operatorButtons[2] = (Button) findViewById(R.id.mul); 
		operatorButtons[3] = (Button) findViewById(R.id.div); 
		
		//Saving a reference to the EditText "disp"
		disp = (EditText) findViewById(R.id.display); 
		
		cancel = (Button) findViewById(R.id.clear); 
		cancel.setOnClickListener(new OnClickListener() {
										@Override			
										public void onClick(View arg0)
										{
											op1 = 0;
											op2 = 0;
											operator = "";
											disp.setText("");
										}
									}); 

		equal = (Button) findViewById(R.id.equal);
		equal.setOnClickListener(new CalculateListener());

		// Setting listener for digit buttons
		for(int i =0; i<=9; i++)
		{
			TextButtonListener listener = new TextButtonListener((String) textButtons[i].getText());
			textButtons[i].setOnClickListener(listener); 
		}
		
		// Setting listener for operator buttons
		for (int i =0; i<4; i++ )
		{
			OperatorButtonListener operatorListener = new OperatorButtonListener((String)operatorButtons[i].getText());
			operatorButtons[i].setOnClickListener(operatorListener); 
		}
	} 

	// method that handles calculations
	public void calculate(){
		
		if(operator.equals("+")){
			op1 = op1 + op2;  
		} 
		else if(operator.equals("-")){ 
			op1 = op1 - op2;			 
		} 
		else if(operator.equals("*")){  
			op1 = op1 * op2;  
		} 
		else if(operator.equals("/")){ 
			
			if(op2 == 0){
				Toast.makeText(this, "can not divide by zero", Toast.LENGTH_SHORT).show();
				disp.setText("");
				return;
			}
			op1 = op1 / op2;			
		}
		disp.setText(Integer.toString(op1));
	} 

	//Text Button Listener 	
	public class TextButtonListener implements View.OnClickListener 
	{
		String string;

		public TextButtonListener(String str)
		{
			string = str;
		}

		public void onClick(View arg0) 
		{ 
			disp.append(string);
		}
	} 

	//Operator Button Listener 	
	public class OperatorButtonListener implements View.OnClickListener 
	{
		String buttonOperator;

		public OperatorButtonListener(String str)
		{
			buttonOperator = str;
		}

		public void onClick(View arg0) 
		{ 
			String t = disp.getText().toString();
			
			if(t.isEmpty())
			{
				t = "0";
			}
			
			op1= Integer.parseInt(t);
			operator = buttonOperator ;
			disp.setText("");
			
			//Log.d("Calculator_Button_listener", "We are here! "+operator);
		}
	}

	//This is what happens when you want to calculate the answer 	
	public class CalculateListener implements View.OnClickListener 
	{

		public void onClick(View arg0) 
		{ 
			String t = disp.getText().toString();
						
			if(t.isEmpty())
			{
				t = "0";
			}
			
			op2 = Integer.parseInt(t);
			calculate();
		}
	}
}
